package test;

import org.jboss.internal.soa.esb.message.format.xml.ContextImpl;

import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.message.format.MessageFactory;
import org.jboss.soa.esb.client.ServiceInvoker;

/**
 *
 * @author
 */
public class ReproducerMain {

    private static Integer sessionId = -1;
    private static Long processInstanceId = -1L;

    private static void startProcess() throws Exception {
        Message esbMessage = MessageFactory.getInstance().getMessage();
        esbMessage.getProperties().setProperty("name", "Laurel");
        esbMessage.getBody().add("Empty");
        Message esbResponseMessage = new ServiceInvoker("FirstServiceESB", "StartListener").deliverSync(esbMessage, 5000L);
        ContextImpl ctxi = (ContextImpl) esbResponseMessage.getContext();

        sessionId = (Integer) ctxi.getContext("jbpm5-session-id");
        processInstanceId = (Long) ctxi.getContext("jbpm5-processinstance-id");
    }

    private static void signalProcess() throws Exception {
        Message esbMessage = MessageFactory.getInstance().getMessage();
        esbMessage.getBody().add("Empty");
        esbMessage.getProperties().setProperty("processEventType", "NewMessage");
        esbMessage.getProperties().setProperty("name", "Hardy");

        ContextImpl ctxi = (ContextImpl) esbMessage.getContext();
        ctxi.setContext("jbpm5-session-id", sessionId);
        ctxi.setContext("jbpm5-processinstance-id", processInstanceId);

        new ServiceInvoker("FirstServiceESB", "SignalListener").deliverSync(esbMessage, 5000L);
        Thread.sleep(4000);
    }

    public static void main(String ... args) throws Exception {
        System.setProperty("javax.xml.registry.ConnectionFactoryClass", "org.apache.ws.scout.registry.ConnectionFactoryImpl");
        System.out.println("[TEST] testSignalEvent");
        System.out.println("\tStarting process ...");
        startProcess();
        System.out.println("\tSignalling process ...");
        signalProcess();
    }

}